#!/usr/bin/env node

const inquirer = require("inquirer");
const chalk = require("chalk");
const fs = require("fs");
const tplObj = require("../template.json");

let question = [
  {
    name: "name",
    type: "input",
    message: "请输入模板名称",
    validate(val) {
      if (val === "") {
        return "模板名称不能为空";
      }
      const templatename = tplObj.find((item) => item.name === val);
      if (templatename) {
        return "模板名称已经存在";
      }
      return true;
    },
  },
  {
    name: "url",
    type: "input",
    message: "请输入模板地址",
    validate(url) {
      if (url === "") return "模板地址不能为空";
      return true;
    },
  },
];

inquirer.prompt(question).then((answers) => {
  let { name, url } = answers;
  console.log(answers, "answers");
  tplObj.push(answers);
  fs.writeFile(
    `${__dirname}/../template.json`,
    JSON.stringify(tplObj),
    "utf-8",
    (err) => {
      if (err) console.log(err);
      console.log("\n");
      console.log(chalk.green("模板添加成功"));
      console.log(chalk.grey("当前本地最新模板列表如下：\n"));
      console.log(tplObj);
    }
  );
});
