#!/usr/bin/env node
const inquirer = require("inquirer");
const chalk = require("chalk");
const fs = require("fs");
const tplObj = require("../template");

let question = [
  {
    name: "name",
    message: "请输入要删除的模板名称",
    validate(name) {
      if (name === "") {
        return "模板名称不能为空";
      }
      const templatename = tplObj.find((item) => item.name === name);
      if (!templatename) {
        return "模板不存在";
      }
      return true;
    },
  },
];

inquirer.prompt(question).then((answers) => {
  let { name } = answers;
  JsonDelItems(tplObj, name);
  fs.writeFile(
    `${__dirname}/../template.json`,
    JSON.stringify(tplObj),
    "utf-8",
    (err) => {
      if (err) console.log(err);
      console.log(chalk.green("模板删除成功\n"));
      console.log(chalk.yellow("当前可用模板列表如下：\n"));
      console.log(tplObj);
    }
  );
});

// 删除单个指定内容
function JsonDelItems(JSONArray, name) {
  for (var i = 0; i < JSONArray.length; i++) {
    if (JSONArray[i].name == name) {
      tplObj.splice(i, 1);
      break;
    }
  }
}
