#!/usr/bin/env node

const inquirer = require("inquirer");
const chalk = require("chalk");
const fs = require("fs");
const tplObj = require("../template.json");

let question = [
  {
    name: "name",
    type: "input",
    message: "请输入旧模板名称",
    validate(val) {
      if (val === "") {
        return "旧模板名称不能为空";
      }
      const templatename = tplObj.find((item) => item.name === val);
      if (!templatename) {
        return "模板不存在";
      }
      return true;
    },
  },
  {
    name: "newname",
    type: "input",
    message: "请输入新模板名称",
    validate(newval) {
      if (newval === "") {
        return "新模板名称不能为空";
      }
      const templatename = tplObj.find((item) => item.name === newval);
      if (templatename) {
        return "模板名称已经存在";
      }
      return true;
    },
  },
];
let question2 = [
  {
    name: "name",
    type: "input",
    message: "请输入模板名称",
    validate(val) {
      if (val === "") {
        return "模板名称不能为空";
      }
      const templatename = tplObj.find((item) => item.name === val);
      if (!templatename) {
        return "模板名称已经存在";
      }
      return true;
    },
  },
  {
    name: "url",
    type: "input",
    message: "请输入旧模板地址",
    validate(val) {
      if (val === "") {
        return "旧模板地址不能为空";
      }
      return true;
    },
  },
  {
    name: "url2",
    type: "input",
    message: "请输入新模板地址",
    validate(newval) {
      if (newval === "") {
        return "新模板地址不能为空";
      }
      return true;
    },
  },
];
typeConfirm();
function typeConfirm() {
  inquirer
    .prompt([
      {
        type: "confirm",
        message: "是否修改模板名称？",
        name: "ok",
        default: true,
      },
    ])
    .then((res) => {
      if (res.ok) {
        typeInput();
      } else {
        typeConfirm1();
      }
    });
}

function typeInput() {
  inquirer.prompt(question).then((res) => {
    console.log(res, "res");
    if (res) typeConfirm1(res);
  });
}

function typeConfirm1(resname) {
  inquirer
    .prompt([
      {
        type: "confirm",
        message: "是否修改模板地址？",
        name: "ok",
        default: true,
      },
    ])
    .then((res) => {
      if (res.ok) {
        typeInput1();
      } else {
        if (resname) {
          writeFileName(resname);
          console.log("拒绝");
        }
      }
    });
}

function typeInput1() {
  inquirer.prompt(question2).then((res) => {
    console.log(res, "地址");
    if (res) writeFileUrl(res);
  });
}

function writeFileName(data) {
  console.log(data, "data");
  NameItems(tplObj, data);
  fs.writeFile(
    `${__dirname}/../template.json`,
    JSON.stringify(tplObj),
    "utf-8",
    (err) => {
      if (err) console.log(err);
      console.log("\n");
      console.log(chalk.green("模板替换成功"));
      console.log(chalk.grey("当前最新模板列表如下：\n"));
      console.log(tplObj);
    }
  );
}
function NameItems(JSONArray, data) {
  for (var i = 0; i < JSONArray.length; i++) {
    if (JSONArray[i].name == data.name) {
      console.log(JSONArray[i].name, "q2");
      tplObj[i].name = data.newname;
      break;
    }
  }
}
function writeFileUrl(path) {
  console.log(path, "data");
  pathItems(tplObj, path);
  fs.writeFile(
    `${__dirname}/../template.json`,
    JSON.stringify(tplObj),
    "utf-8",
    (err) => {
      if (err) console.log(err);
      console.log("\n");
      console.log(chalk.green("模板添加成功"));
      console.log(chalk.grey("当前本地最新模板列表如下：\n"));
      console.log(tplObj);
    }
  );
}
function pathItems(JSONArray, path) {
  for (var i = 0; i < JSONArray.length; i++) {
    if (JSONArray[i].name == path.name) {
      tplObj[i].url = path.url2;
      break;
    }
  }
}
